/****************************************************************
 AttrValuePair.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "AttrValuePair.H"
#include <iostream>


AttrValuePair::AttrValuePair(int attribute,double value)
  : attribute(attribute), value(value)
{
  // ctor
}



AttrValuePair::AttrValuePair(int attribute,int value)
  : attribute(attribute), value((double) value)
{
  // ctor
}



int AttrValuePair::getAttribute()
{
  return attribute;
}



double AttrValuePair::getFloatValue()
{
  return value;
}



int AttrValuePair::getIntValue()
{
  return (int) value;
}


void AttrValuePair::printOn(ostream &os)
{
  os<<"("<<attribute<<","<<value<<")";
}



ostream &operator<<(ostream &os,AttrValuePair &p)
{
  p.printOn(os);
  return os;
}


