/****************************************************************
 Case.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Case.H"
#include <iostream>


Case::Case(int numAttributes)
  : array(numAttributes)
{
  // ctor
}



double Case::getContinuous(int attrNum)
{
  return array[attrNum];
}



int Case::getDiscrete(int attrNum)
{
  return int(array[attrNum]);
}



void Case::setContinuous(int attrNum,double f)
{
  array[attrNum]=f;
}



void Case::setDiscrete(int attrNum,int x)
{
  array[attrNum]=double(x);
}



int Case::getNumAttributes()
{
  return array.size();
}



void Case::printOn(ostream &os)
{
  int i, n=array.size();
  for(i=0 ; i<n ; ++i)
    os << array[i] << ' ';
}



ostream &operator<<(ostream &os,const Case &c)
{
  ((Case &)c).printOn(os);
  return os;
}



void Case::resize(int newSize)
{
  array.resize(newSize);
}


