/****************************************************************
 DecisionTree.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_DecisionTree_H
#define INCL_DecisionTree_H

#include "TreeNode.H"
#include "tigr++/TigrString.H"
#include "tigr++/TigrVector.H"
#include <iostream>

class DecisionTree
{
  TreeNode *root;

  static void dfs(TreeNode *,ostream &);
  static void dfs(TreeNode *,TigrVector<float> &);
public:
  DecisionTree(TreeNode *root);
  TreeNode *getRoot();
  void save(TigrString filename);
  void load(TigrString filename);
  void getEntropies(TigrVector<float> &);
};


#endif
