/****************************************************************
 CrossPtCollector.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "CrossPtCollector.H"
#include <iostream>
using namespace std;


CrossPtCollector::CrossPtCollector()
{
  // ctor
}



TigrVector<CrossoverPoint> *CrossPtCollector::collectPoints(TreeNode *root)
{
  TigrVector<CrossoverPoint> *points=new TigrVector<CrossoverPoint>();

  addPointsRecurs(*root,*points,0);

  return points;
}



void CrossPtCollector::addPointsRecurs(TreeNode &node,
				       TigrVector<CrossoverPoint> &points,
				       int depth)
{
  int i, n=node.getNumChildren();
  for(i=0 ; i<n ; ++i)
    {
      points.push_back(CrossoverPoint(&node,i,depth));
      addPointsRecurs(*node.getIthChild(i),points,depth+1);
    }
}



