/****************************************************************
 CrossoverPoint.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "CrossoverPoint.H"
#include <iostream>
using namespace std;


CrossoverPoint::CrossoverPoint()
{
  // default ctor
}



CrossoverPoint::CrossoverPoint(const CrossoverPoint &other)
  : parent(other.parent), childNum(other.childNum),
    depth(other.depth)
{
  // copy ctor
}



CrossoverPoint::CrossoverPoint(TreeNode *parent,int childNum,int depth)
  : parent(parent), childNum(childNum), depth(depth)
{
  // ctor
}



CrossoverPoint &CrossoverPoint::operator=(const CrossoverPoint &other)
{
  parent=other.parent;
  childNum=other.childNum;
}



TreeNode *CrossoverPoint::getParent() const
{
  return parent;
}



int CrossoverPoint::getChildNum() const
{
  return childNum;
}



int CrossoverPoint::getDepth() const
{
  return depth;
}



void CrossoverPoint::performCrossover(CrossoverPoint *other)
{
  TreeNode *myChild=parent->getIthChild(childNum);
  TreeNode *herChild=other->parent->getIthChild(other->childNum);
  
  parent->setIthChild(childNum,herChild);
  other->parent->setIthChild(other->childNum,myChild);
}


