/****************************************************************
 FitnessNormalizer.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "FitnessNormalizer.H"

// **************************************************
//               FitnessNormalizer methods
// **************************************************

void FitnessNormalizer::normalize(Population &population)
{
  const float adjustedSum=sumAdjusted(&population);

  int i, n=population.size();
  for(i=0 ; i<n ; ++i)
    {
      Individual *individual=population.getMember(i);
      const float adjusted=individual->getAdjustedFitness();
      const float normalized=adjusted/adjustedSum;
      individual->setNormalizedFitness(normalized);
    }
}



float FitnessNormalizer::sumAdjusted(Population *population)
{
  float sum=0.0;

  int i, n=population->size();
  for(i=0 ; i<n ; ++i)
    {
      Individual *individual=population->getMember(i);
      sum+=individual->getAdjustedFitness();      
    }

  return sum;
}




