/****************************************************************
 IndividualSchema.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "IndividualSchema.H"
#include <iostream>
#include "tigr++/TigrString.H"
using namespace std;


IndividualSchema *IndividualSchema::global;



IndividualSchema::IndividualSchema(int maxCallCount)
  : maxCallCount(maxCallCount)
{
  // ctor
}



void IndividualSchema::addADF(int numParms)
{
  adfs.push_back(numParms);
}



void IndividualSchema::addEntryPoint(int numParms)
{
  entryPoints.push_back(numParms);
}



int IndividualSchema::getNumADFs()
{
  return adfs.size();
}



int IndividualSchema::getNumEntryPoints()
{
  return entryPoints.size();
}



int IndividualSchema::getADFarity(int i)
{
  return adfs[i];
}



int IndividualSchema::getEntryPointArity(int i)
{
  return entryPoints[i];
}



int IndividualSchema::getMaxCallCount()
{
  return maxCallCount;
}



void IndividualSchema::allocateGlobal(int maxCallCount)
{
  global=new IndividualSchema(maxCallCount);
}



IndividualSchema &IndividualSchema::getGlobal()
{
#ifdef DEBUG
  if(!global) 
    throw "IndividualSchema::getGlobal() called before global object has been allocated";
#endif

  return *global;
}


