/****************************************************************
 IndividualSchema.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_IndividualSchema_H
#define INCL_IndividualSchema_H

#include "tigr++/TigrVector.H"

class IndividualSchema
{
  TigrVector<int> adfs;
  TigrVector<int> entryPoints;
  //bool recursionAllowed;
  int maxCallCount;
  static IndividualSchema *global;

  IndividualSchema(/*bool recursionAllowed,*/int maxCallCount);
public:
  static void allocateGlobal(int maxCallCount);
  static IndividualSchema &getGlobal();
  void addADF(int numParms);
  void addEntryPoint(int numParms);
  int getNumADFs();
  int getNumEntryPoints();
  int getADFarity(int i);
  int getEntryPointArity(int i);
  //bool isRecursionAllowed();
  int getMaxCallCount();
};


#endif
