/****************************************************************
 Population.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Population_H
#define INCL_Population_H

#include "Individual.H"
#include "tigr++/TigrVector.H"
#include <iostream>
using namespace std;

class Population
{
  TigrVector<Individual *> members;
  
  int getBestIndex();
public:
  Population();
  virtual ~Population(); // deletes members
  void addMember(Individual *);
  int size();
  Individual *getMember(int);
  Individual *getMostFit();
  Individual *removeMostFit();
  void printOn(ostream &) const;
};

ostream &operator<<(ostream &,const Population &);

#endif
