/****************************************************************
 PopulationBuilder.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "PopulationBuilder.H"
#include <iostream>
using namespace std;


PopulationBuilder::PopulationBuilder(SymbolSet &symbolSet)
  : individualBuilder(symbolSet)
{
  // ctor
}



Population *PopulationBuilder::buildPopulation(int populationSize,
					       int minHeight,
					       int maxHeight)
{
  Population *population=new Population();

  int numHeights=maxHeight-minHeight+1;
  int numPerHeight=int(populationSize/float(numHeights)+1);

  int i, height=minHeight, numAtHeight=0;
  for(i=0 ; i<populationSize ; ++i)
    {
      Individual *individual=individualBuilder.buildIndividual(height);
      population->addMember(individual);

      ++numAtHeight;
      if(numAtHeight==numPerHeight)
	{
	  ++height;
	  numAtHeight=0;
	}
    }

  return population;
}



