/****************************************************************
 SymbolSet.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "SymbolSet.H"
#include <iostream>
#include "tigr++/TigrRandom.H"
using namespace std;

SymbolSet::SymbolSet()
{
  // ctor
}



void SymbolSet::addNonterminal(TreeNode *node)
{
  nonterminals.push_back(node);
}



void SymbolSet::addTerminal(TreeNode *node)
{
  terminals.push_back(node);
}



TigrVector<TreeNode*> &SymbolSet::getNonterminals()
{
  return nonterminals;
}



TigrVector<TreeNode*> &SymbolSet::getTerminals()
{
  return terminals;
}






TreeNode *SymbolSet::randomTerminal()
{
  return terminals[RandomNumber(terminals.size())]->instantiate();
}



TreeNode *SymbolSet::randomNonterminal()
{
  return nonterminals[RandomNumber(nonterminals.size())]->instantiate();
}
