/****************************************************************
 Tournament.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Tournament.H"
#include "tigr++/TigrRandom.H"


Tournament::Tournament(Population &population,int size)
  : v(size)
{
  int i;
  for(i=0 ; i<size ; ++i)
    {
      const int index=RandomNumber(population.size());
      v[i]=population.getMember(index);
    }

  wheel=new RouletteWheel(v,size);
}



Tournament::~Tournament()
{
  // dtor

  delete wheel;
}



Individual *Tournament::pickWinner()
{
  return v[wheel->spin()];
}


