/****************************************************************
 TreeBuilder.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "TreeBuilder.H"
#include <iostream>
#include "tigr++/TigrRandom.H"
using namespace std;


TreeBuilder::TreeBuilder(SymbolSet &symbolSet)
  : symbolSet(symbolSet)
{
  // ctor
}



TreeNode *TreeBuilder::buildTree(int height)
{
  switch(height)
    {
    case 0:
      return NULL;
    case 1:
      return symbolSet.randomTerminal();
    }

  TreeNode *root=symbolSet.randomNonterminal();
  int i, n=root->getArity();
  for(i=0 ; i<n ; ++i)
    {
      TreeNode *child=buildTree(height-1);
      root->addChild(child);
    }

  return root;
}



