/****************************************************************
 Schema.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Schema_H
#define INCL_Schema_H

#include "TypeDescriptor.H"
#include "tigr++/TigrVector.H"
#include "tigr++/TigrMap.H"
#include <iostream>


class TrainingSet;

class Schema
{
  int numCategories;
  TigrVector<TypeDescriptor*> v;
  TigrMap<int,int> *maps;
public:
  Schema(int numCategories);
  void add(TypeDescriptor *);
  int numAttributes();
  TypeDescriptor *operator[](int);
  int getNumCategories();
  void removeAttribute(int);
  TigrMap<int,int> *countDiscrete(TrainingSet &);
  void printOn(ostream &) const;
};

ostream &operator<<(ostream &,const Schema &);

#endif
