/****************************************************************
 TrainingSet.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_TrainingSet_H
#define INCL_TrainingSet_H

#include "Schema.H"
#include "tigr++/TigrVector.H"
#include "tigr++/TigrString.H"
#include "TrainingCase.H"

class TrainingSet
{
  Schema &schema;
  TigrVector<TrainingCase *> theVector;

  void load(TigrString &filename);
public:
  TrainingSet(Schema &,TigrString filename);
  TrainingSet(Schema &);
  TrainingCase &getCase(int i);
  int numCases();
  Schema &getSchema();
  TrainingSet *getCategory(int category);
  void addCase(TrainingCase *);
  void deleteCases();
};


#endif
