/****************************************************************
 TypeDescriptor.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "TypeDescriptor.H"
#include <iostream>


ostream &operator<<(ostream &os,const TypeDescriptor &d)
{
  d.printOn(os);
  return os;
}



TypeDescriptor::TypeDescriptor(DescriptorType t,TigrString name)
  : type(t), name(name)
{
  // ctor
}



DescriptorType TypeDescriptor::getType() const
{
  return type;
}



TigrString TypeDescriptor::getName() const
{
  return name;
}



Discrete::Discrete(int n,TigrString name)
  : TypeDescriptor(DISCRETE,name), n(n)
{
  // ctor
}



int Discrete::getN()
{
  return n;
}



void Discrete::setN(int newN)
{
  n=newN;
}



void Discrete::printOn(ostream &os) const
{
  os << getName().c_str() << ": discrete";
}



Continuous::Continuous(TigrString name)
  : TypeDescriptor(CONTINUOUS,name)
{
  // ctor
}



void Continuous::printOn(ostream &os) const
{
  os << getName().c_str() << ": continuous";
}


