/****************************************************************
 TypeDescriptor.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_TypeDescriptor_H
#define INCL_TypeDescriptor_H

#include <iostream>
#include "tigr++/TigrString.H"

enum DescriptorType
{
  DISCRETE,
  CONTINUOUS
};

class TypeDescriptor
{
  TigrString name;
  DescriptorType type;
public:
  TypeDescriptor(DescriptorType,TigrString name);
  DescriptorType getType() const;
  TigrString getName() const;
  virtual void printOn(ostream &) const=0;
};

ostream &operator<<(ostream &,const TypeDescriptor &);

class Discrete : public TypeDescriptor
{
  int n;
public:
  Discrete(int,TigrString name);
  void setN(int);
  int getN();
  virtual void printOn(ostream &) const;
};

class Continuous : public TypeDescriptor
{
public:
  Continuous(TigrString name);
  virtual void printOn(ostream &) const;
};

#endif
