/****************************************************************
 DataSetStatistics.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "DataSetStatistics.H"


DataSetStatistics::DataSetStatistics(TrainingSet &d)
  : dataSet(d)
{
  // ctor
}



void DataSetStatistics::getPredictorStats(int i,float &min,float &max)
{
  // Initialize min and max to values of first case
  Case &firstCase=dataSet.getCase(0);
  min=max=firstCase.getContinuous(i);
  
  // Iterate through all cases, noting values less than min or
  // greater than max
  int n=dataSet.numCases();
  for(int j=0 ; j<n ; ++j)
    {
      Case &c=dataSet.getCase(j);
      float value=c.getContinuous(i);
      if(value<min)
	min=value;
      else if(value>max)
	max=value;
    }
}



TigrMap<int,int> *DataSetStatistics::getX2Index()
{
  TigrMap<int,int> &m=*new TigrMap<int,int>;

  int index=0, n=dataSet.numCases();
  for(int i=0 ; i<n ; ++i)
    {
      TrainingCase &c=dataSet.getCase(i);
      int category=c.getCategory();
      if(!m.isDefined(category)) 
	{
	  m[category]=index;
	  ++index;
	}
    }

  return &m;
}


