/****************************************************************
 ModelBuilder.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_ModelBuilder_H
#define INCL_ModelBuilder_H

#include "Model.H"
#include "DataSetStatistics.H"
#include "../Schema.H"
#include "../TrainingCase.H"
#include "../TrainingSet.H"

class ModelBuilder
{
  TrainingSet &dataSet;
  DataSetStatistics dataSetStats;
  int numCategories;
  int numPredictors;
  Schema &schema;

  PublicModel *buildPublicModel();
  void allocateDiscretizers(PublicModel *);
  void processTrainingCases(PublicModel *);
  void processPredictors(TrainingCase &,PublicModel *,int categoryIndex);
  void divideYStructure(PublicModel *);
  void divideCategoriesBy(PublicModel *,int numCases);
public:
  ModelBuilder(TrainingSet &,Schema &);
  Model *buildModel();
};

#endif
