/****************************************************************
 PublicModel.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "PublicModel.H"

PublicModel::PublicModel(int numPredictors,int numCategories,
			 TigrMap<int,int> &x2index)
  : yStructure(numPredictors,numCategories),
    xProportions(numCategories),
    x2index(x2index)
{
  // ctor

  xProportions.setAllTo(0.0);

  // Invert the map
  TigrMap<int,int>::iterator cur=x2index.begin(), end=x2index.end();
  for(; cur!=end ; ++cur)
    index2x[(*cur).second]=(*cur).first;
}



