/****************************************************************
 YStructure.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "YStructure.H"

YStructure::YStructure(int numPredictors,int numCategories)
  : array(numPredictors)
{
  for(int i=0 ; i<numPredictors ; ++i)
    array[i]=new YStructureElement(numCategories);
}



float &YStructure::lookup(int whichPredictor,int predictorValue,
			  int categoryIndex)
{
  YStructureElement *elem=array[whichPredictor];
  return elem->probability(predictorValue,categoryIndex);
}



void YStructure::allocateDiscretizer(int whichPredictor,float minValue,
				     float bucketSize)
{
  YStructureElement *elem=array[whichPredictor];
  elem->allocateDiscretizer(minValue,bucketSize);
}



YStructureElement &YStructure::operator[](int i)
{
  return *array[i];
}



int YStructure::getNumPredictors() const
{
  return array.size();
}


