/****************************************************************
 YStructure.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_YStructure_H
#define INCL_YStructure_H

#include "tigr++/TigrArray1D.H"
#include "YStructureElement.H"

class YStructure
{
  TigrArray1D<YStructureElement*> array;
  int numCategories;
public:
  YStructure(int numPredictors,int numCategories);
  float &lookup(int whichPredictor,int predictorValue,
		int categoryIndex);
  void allocateDiscretizer(int whichPredictor,float minValue,
			   float bucketSize);
  YStructureElement &operator[](int);
  int getNumPredictors() const;
};

#endif
