/****************************************************************
 YStructureElement.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "YStructureElement.H"
#include "tigr++/TigrArray1D.H"


YStructureElement::YStructureElement(int numCategories)
  : discretizer(NULL), 
    numCategories(numCategories)
{
  // ctor
}



float &YStructureElement::probability(int predictorValue,
				      int categoryIndex)
{
  if(!assocArray.isDefined(predictorValue))
    {
      TigrFloatArray1D *newArray=new TigrFloatArray1D(numCategories);
      newArray->setAllTo(0.0);	
      assocArray[predictorValue]=newArray;
    }

  TigrFloatArray1D &array=*assocArray[predictorValue];
  return array[categoryIndex];
}



Discretizer &YStructureElement::getDiscretizer()
{
  if(!discretizer)
    throw "requesting null Discretizer from YStructureElement";
  return *discretizer;
}



void YStructureElement::allocateDiscretizer(float minValue,
					    float bucketSize)
{
  discretizer=new Discretizer(minValue,bucketSize);
}



TigrMap<int,TigrFloatArray1D*>::iterator YStructureElement::getIterator()
{
  return assocArray.begin();
}



TigrMap<int,TigrFloatArray1D*>::iterator YStructureElement::getIteratorEnd()
{
  return assocArray.end();
}



