/****************************************************************
 YStructureElement.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_YStructureElement_H
#define INCL_YStructureElement_H

#include "tigr++/TigrMap.H"
#include "tigr++/TigrArray1D.H"
#include "Discretizer.H"

class YStructureElement
{
  TigrMap<int,TigrFloatArray1D*> assocArray;
  Discretizer *discretizer;
  int numCategories;
public:
  YStructureElement(int numCategories);
  float &probability(int predictorValue,int categoryIndex);
  Discretizer &getDiscretizer();//throws exception
  void allocateDiscretizer(float minValue,float bucketSize);
  TigrMap<int,TigrFloatArray1D*>::iterator getIterator();
  TigrMap<int,TigrFloatArray1D*>::iterator getIteratorEnd();
};

#endif
