#!/usr/bin/perl
use strict;
use TempFilename;

my $usage="$0 <filestem>";
die "$usage\n" unless @ARGV==1;
my ($filestem)=@ARGV;

my $data="$filestem.data";
my $test="$filestem.test";

process($data);
process($test);

my $prevNumFields;
sub process
  {
    my ($filename)=@_;
    my $tmp=TempFilename::generate();
    open(OUT,">$tmp") || die "can't create temp file: $tmp\n";
    open(IN,$filename) || die "can't open $filename\n";
    while(<IN>)
      {
	my @fields=split/\s+/,$_;
	my $numFields=@fields;
	next unless $numFields>0;
	next if(defined($prevNumFields) && $numFields!=$prevNumFields);
	$prevNumFields=$numFields;
	++$fields[$numFields-1];
	my $line=join(' ',@fields);
	print OUT "$line\n";
      }
    close(IN);
    close(OUT);
    system("mv $tmp $filename");
  }



