/****************************************************************
 LogisticFunction.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "LogisticFunction.H"
#include <math.h>
#include "tigr++/TigrStacktrace.H"
#include <iostream>
using namespace std;


float LogisticFunction::operator()(float s)
{
  // implements 1/(1+e^-s)

  const float exp_s=exp(-s);
  
  const float denom=1.0+exp_s;
  
  const float value=1.0/denom;
  
  return value;
}



float LogisticFunction::derivative(float x)
{
  // implements the derivative of this function

  TransferFunction &f=*this;
  return f(x)*(1.0-f(x));
}


