/****************************************************************
 Neuron.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_NEURON_H
#define INCL_NEURON_H

#include <iostream>
#include "tigr++/TigrStacktrace.H"
#include "tigr++/TigrVector.H"
#include "Synapse.H"
#include "NeuralNetwork.H"
#include "NeuronType.H"

// *************************************************
//  		    class Neuron
// *************************************************
class Neuron
{
  float activationValue;
  float combinedInputs;
  TigrVector<Synapse*> inputs, outputs;
  NeuronType &type;
protected:
  void changeActivationValue(float);
public:
  Neuron(float initialValue,NeuronType &);
  virtual ~Neuron();
  void addInput(const Synapse *);
  void addOutput(const Synapse *);
  int getInDegree() const;
  int getOutDegree() const;
  Synapse &getInput(int);
  Synapse &getOutput(int);
  float getActivationValue() const;
  void update(NeuralNetwork &);
  void setActivationValue(float);
  float getCombinedInputs();
  virtual void saveSelf(ostream &);
  virtual void loadSelf(istream &,NeuralNetwork &);
};


#endif
