/****************************************************************
 Normalizer.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_Normalizer_H
#define INCL_Normalizer_H

#include "tigr++/TigrVector.H"
#include "NeuralCase.H"

class Normalizer
{
  int numInputs, numOutputs;
  DoubleVector maxInput, maxOutput;
  DoubleVector minInput, minOutput;

  void findMaxima(TigrVector<NeuralCase*> &);
  void findMinima(TigrVector<NeuralCase*> &);
  void adjust(float factor,DoubleVector &,int n);
public:
  Normalizer(int numInputs,int numOutputs);
  void normalize(TigrVector<NeuralCase*> &,
		 float maxAdjuster=1.0,
		 float minAdjuster=1.0);
  void normalize(NeuralCase *,float maxAdjuster=1.0,
		 float minAdjuster=1.0);
  float denormalizeOutput(float value,int outputIndex);
};

#endif
