/****************************************************************
 SigmaFunction.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "SigmaFunction.H"
#include "Neuron.H"
#include "NeuralNetwork.H"
#include "tigr++/TigrExceptions.H"
#include <iostream>
using namespace std;

float SigmaFunction::operator()(Neuron &neuron,NeuralNetwork &network)
{
  float sigma=0.0;
  
  const int num=neuron.getInDegree();
  int i;
  for(i=0 ; i<num ; ++i)
    {
      Synapse &synapse=neuron.getInput(i);
      const float weight=synapse.getWeight();
      const int index=synapse.getFrom();
      const float value=network[index].getActivationValue();
      const float product=weight*value;
      sigma+=product;
    }
  
  return sigma;
}

