/****************************************************************
 Synapse.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "Synapse.H"

Synapse::Synapse()
  : weight(0.0), from(-1), to(-1)
{
  // ctor
}



Synapse::Synapse(float weight,int from,int to)
  : weight(weight), from(from), to(to)
{
  // ctor
}



float Synapse::getWeight() const
{
  return weight;
}



int Synapse::getFrom() const
{
  return from;
}



int Synapse::getTo() const
{
  return to;
}



void Synapse::changeWeight(float w)
{
  weight=w;
}



Synapse &Synapse::operator=(const Synapse &synapse)
{
  weight=synapse.weight;
  from=synapse.from;
  to=synapse.to;
  
  return *this;
}



void Synapse::saveSelf(ostream &os)
{
  /*
    The file format for a synapse is:

    ----------
    from
    to
    weight
    ----------
    */

  os << from << endl;
  os << to << endl;
  os << weight << endl;
}



void Synapse::loadSelf(istream &is)
{
  is >> from >> to >> weight;
}



