/****************************************************************
 TigrStack.H

 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_TigrStack_H
#define INCL_TigrStack_H
#include <stack>
using namespace std;

template<class T>
class TigrStack
{
public:
  TigrStack();
  void push(const T &);
  const T &pop(); // removes & returns the top element!
  const T &top();
  int size() const;
  bool isEmpty() const;
private:
  stack<T> theStack;
};


template<class T>
TigrStack<T>::TigrStack()
{
}



template<class T>
void TigrStack<T>::push(const T &t)
{
  theStack.push(t);
}



template<class T>
const T &TigrStack<T>::pop()
{
  const T &t=theStack.top();
  theStack.pop();
  return t;
}



template<class T>
const T &TigrStack<T>::top()
{
  return theStack.top();
}



template<class T>
int TigrStack<T>::size() const
{
  return theStack.size();
}



template<class T>
bool TigrStack<T>::isEmpty() const
{
  return theStack.empty();
}


#endif
